---
name: Bug report
about: Create a report to let us know about issue in Rspamd
title: "[BUG]"
labels: bug
assignees: ''

---

<!--

Do you want to ask a question? Are you looking for support? Here are the places where you can get what you need: https://rspamd.com/support.html

-->

### Prerequisites

* [ ] Put an X between the brackets on this line if you have done all of the following:
    * Read about bug reporting in general: https://rspamd.com/doc/faq.html#how-to-report-bugs-found-in-rspamd
    * Enabled relevant debugging logs: https://rspamd.com/doc/faq.html#how-to-debug-some-module-in-rspamd 
    * Checked the FAQs about Core files in case of fatal crash: https://rspamd.com/doc/faq.html#how-to-figure-out-why-rspamd-process-crashed
    * Tried ASAN package and obtained the ASAN report (if possible): https://rspamd.com/doc/faq.html#asan-builds 
    * Checked that your issue isn't already filed: https://github.com/issues?utf8=%E2%9C%93&q=is%3Aissue+user%3Arspamd
    * Checked that there is not already an experimental package or master branch

**Describe the bug**
A clear and concise description of what the bug is.

### Steps to Reproduce

1. [First Step]
2. [Second Step]
3. [and so on...]

**Expected behavior**
A clear and concise description of what you expected to happen.

### Versions

You can get this information from copy and pasting the output of `rspamd --version` from the command line. Also, please include the **OS** and what version and architecture including the generation of CPU model (e.g. Haswell) where applicable,  of the OS you're running.

### Additional Information

Any additional information, configuration or data that might be necessary to reproduce the issue.
